Subject: Re: bug#34170: bitcoin-core bundles leveldb

From: Carl Dong <[email-masked]>
Date: Wed, 5 Jan 2022 12:40:48 -0500

Simon, Maxime, Danny,

Thanks for CCing me on this message! The rationale for bundling leveldb in Bitcoin Core goes a bit beyond convenience, it is several things:

1. The original reason for sub-treeing is that Bitcoin Core used to maintain its own version of leveldb with its own fixes here: https://github.com/bitcoin-core/leveldb-subtree <https://github.com/bitcoin-core/leveldb-subtree>, since then most of these fixes have been upstreamed as of: https://github.com/bitcoin/bitcoin/pull/17398 <https://github.com/bitcoin/bitcoin/pull/17398>
2. We also used to support using an external leveldb, however, it seems that it was fragile to rely on external projects to maintain ABI compatibility, see the quoted IRC bug report here: https://github.com/bitcoin/bitcoin/pull/23282 <https://github.com/bitcoin/bitcoin/pull/23282>. Reasonable minds may disagree on this point, especially coming from Guix where patching is convenient.

In addition to the above, Bitcoin Core experienced a hard fork in 2013 due to database incompatibilities, which has predisposed maintainers towards a more stringent approach with pinning dependencies and their configure/build-time flags. See: https://blog.bitmex.com/bitcoins-consensus-forks/#was-the-2013-incident-a-hardfork <https://blog.bitmex.com/bitcoins-consensus-forks/#was-the-2013-incident-a-hardfork>

Let me know if I can provide more context!

Cheers,
Carl Dong

> On Jan 5, 2022, at 4:45 AM, zimoun <[email-masked]> wrote:
> 
> Hi Maxime,
> 
> On Wed, 05 Jan 2022 at 10:39, Maxime Devos <[email-masked]> wrote:
> 
>>> The package bitcore-core still provides ’leveldb’:
>>> 
>>> [...]
>>> 
>>> and I am not sure to get what is the issue.  Some explanations?
>> 
>> The issue is that bitcoin-core bundles leveldb (which you have shown
>> is still the case), even though leveldb is packaged in Guix.
> 
> Thanks, I missed that ’leveldb’ is packaged in Guix.  Indeed, it should
> preferably be used.
> 
> So reopen. :-)
> 
> 
> Cheers,
> simon